
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "c://classes/bis2040/clips/source/CLIPSSrc/clips.h"
#include "c://classes/bis2040/clips/source/CLIPSSrc/expressn.h"
#include "c://classes/bis2040/clips/source/CLIPSSrc/ruledef.h"


void printRules () {
	char *output;
	struct defrule * rule;

	rule = GetNextDefrule("MAIN");
	while (rule != NULL) {
	   output = GetDefrulePPForm(rule);
	   rule = GetNextDefrule(rule);
	   }
	
}

//This gets the rules in Pretty Print Format and returns them.
//undone check length
#define MAXRULESLENGTH 32000
void *getPPRules() {
    char *oneRule;
	struct defrule * rule;
	//get space for the rule string
    char *output = malloc(MAXRULESLENGTH);
	output[0] ='\0';
    

	//loop through all the rules and store the PP representations
	//in temp
	rule = GetNextDefrule(NULL);
	while (rule != NULL) {
	   oneRule =  GetDefrulePPForm(rule);
	   strcat(output, oneRule);
	   if (strlen(output) > MAXRULESLENGTH - 100)
		   printf("probably out of rule string space \n");
	   
	   /*printf(output);
	   printf("\n");*/
	   
	   rule = GetNextDefrule(rule);
	   }


    //Use AddSymbol to copy the string
	//I'm not sure about this, but I think AddSymbol puts it
	//in safe space
	return(AddSymbol(output));
}

//this takes in a PP activation and returns the rules name
//in the ruleActivation. It's internal and is not accessible
//from Clips.   
void getRuleName(char *ruleActivation) {
	char *nameEnd;

	nameEnd = strchr(ruleActivation,':');
	*nameEnd = '\0';
	//undone might have a problem  with different salience values.
	strcpy (ruleActivation,ruleActivation+7);
}

//change the salience of all activations with ruleName to salienceValue
void setRuleSalience () {
	char *ruleName;
	long salienceValue;
	struct defrule * rule;
	void * activationPtr;
	char outBuffer[100];

	if (ArgCountCheck("setRuleSalience",EXACTLY,2) == -1) {
       printf("wrong number of arguments to setRuleSalience\n");
	   return;
	}

	ruleName = RtnLexeme(1);
	salienceValue = RtnLong(2);

	rule = FindDefrule(ruleName);

	if (rule == NULL) {
		printf("There is no rule named ");
		printf (ruleName);
		printf ("\n");
		return;
	}

	//loop through all activations
	activationPtr = GetNextActivation(NULL);
	while (activationPtr != NULL) {
        GetActivationPPForm(outBuffer,100,activationPtr);
        getRuleName(outBuffer);
		if (strcmp(ruleName,outBuffer) == 0) {
           SetActivationSalience(activationPtr,salienceValue);
		   ReorderAgenda(NULL);
		}
		activationPtr = GetNextActivation(activationPtr);
	}  	   

	return;  
}


int isRuleExecutable() {
	char *ruleName;
	void * activationPtr;
	char outBuffer[100];
	
	if (ArgCountCheck("setRuleSalience",EXACTLY,1) == -1) {
       printf("wrong number of arguments to isRuleExecutable\n");
	   return (0);
	}

	ruleName = RtnLexeme(1);
    
	//loop through all activations
	activationPtr = GetNextActivation(NULL);
	while (activationPtr != NULL) {
        GetActivationPPForm(outBuffer,100,activationPtr);
        getRuleName(outBuffer);
		if (strcmp(ruleName,outBuffer) == 0)
			return (1);
    	activationPtr = GetNextActivation(activationPtr);
	}  	   

	return(0);
}
